
#this file runs experiments of Appendix I.1.6 Outperform the best expert
# which_methods
# ['Model Picker', 'Query by Committee', 'Structural Query by Committee', 'Random Sampling',
#'Importance Weighted Active Learning', 'Efficient Active Learning',
#"Oracle","CAMS","CAMS-MAX","contextual qbc","contextual iwal"])

#HIV
declare -a budget=(10 20 30 40 50 100 150 200 250 400 650 800 1400 2000)
declare -a num_reals=(200)

declare -a which_methods=(0 0 0 0 0 0 0 1 0 0 0)
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_CAMS.txt  &

declare -a which_methods=(0 0 0 0 0 0 0 0 1 0 0)
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_CAMS_max.txt  &

declare -a which_methods=(0 0 0 0 0 0 0 0 0 1 0)
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_CAMS_random_policy.txt  &

#random policies
declare -a which_methods=(0 0 0 0 0 0 1 0 0 0 0)

python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 0 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_0.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 1 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_1.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 2 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_2.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 3 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_3.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 4 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_4.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 5 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_5.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 6 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_6.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 7 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_7.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 8 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_8.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 9 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_9.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 10 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_10.txt  &


python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 11 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_classifier_11.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 12 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_classifier_12.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 13 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_classifier_13.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 14 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_classifier_14.txt  &


python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 15 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_15.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 16 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_16.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 17 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_17.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 18 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_18.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 19 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_19.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 20 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_20.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 21 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_21.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 22 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_22.txt  &


#no more policy
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 23 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_23.txt  &
python -m experiments.run_experiment -dataset HIV_contextual  -stream_size 4000 -p 24 -num_reals ${num_reals[@]}  -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_HIV_policy_24.txt  &



#VERTEBRAL
declare -a budget=(2 12 20 30 40 50 60 80)
declare -a num_reals=(200)
declare -a stream_size=(80)

declare -a which_methods=(0 0 0 0 0 0 0 1 0 0 0)
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_VERTEBRAL_CAMS.txt  &

declare -a which_methods=(0 0 0 0 0 0 0 0 1 0 0)
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_VERTEBRAL_CAMS_max.txt  &

declare -a which_methods=(0 0 0 0 0 0 0 0 0 1 0)
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task4/task4_VERTEBRAL_CAMS_random_policy.txt  &


#normal policy
declare -a which_methods=(0 0 0 0 0 0 1 0 0 0 0)

python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 0 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_0.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 1 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_1.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 2 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_2.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 3 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_3.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 4 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_4.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 5 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_5.txt &

#classifier
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 6 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_classifier_6.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 7 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_classifier_7.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 8 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_classifier_8.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 9 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_classifier_9.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 10 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} > ./task4/task4_VERTEBRAL_classifier_10.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 11 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} > ./task4/task4_VERTEBRAL_classifier_11.txt &

#random policy
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 12 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_12.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 13 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_13.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 14 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_14.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 15 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_15.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 16 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_16.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 17 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_17.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 18 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_18.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 19 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_19.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 20 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_20.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 21 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_21.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 22 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_22.txt &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual -stream_size ${stream_size[@]}  -p 23 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} >  ./task4/task4_VERTEBRAL_policy_23.txt &