
#this file runs experiments of Appendix I.1.4 Comparing CAMS and Model Picker in a context-free environment


# which_methods
# ['Model Picker', 'Query by Committee', 'Structural Query by Committee', 'Random Sampling',
# 'Importance Weighted Active Learning', 'Efficient Active Learning',
# "active picker single policy","active picker identity","active picker test","contextual qbc","contextual iwal"])



#CIFAR10
declare -a budget=(10 15 20 25 50 100 150 200 300 400 800 1000 1200)
declare -a which_methods=(1 0 0 0 0 0 0 1 0 0 0)
declare -a num_reals=(20)
python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 11 -num_reals ${num_reals[@]} -budget ${budget[@]}  -which_methods ${which_methods[@]} > ./task7/task7_cifar_mp_cams.txt &


#policies
declare -a which_methods=(0 0 0 0 0 0 1 0 0 0 0)
python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 4 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_4.txt  &
python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 12 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_12.txt  &
python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 14 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_14.txt  &
python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 17 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_17.txt  &
python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 20 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_20.txt  &


# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 0 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_0.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 1 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_1.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 2 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_2.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 3 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_3.txt  &

# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 5 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_5.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 6 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_6.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 7 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_7.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 8 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_8.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 9 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_9.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 10 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_10.txt  &

# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 11 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_11.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 13 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_13.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 15 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_15.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 16 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_16.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 18 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_18.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 19 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_19.txt  &


# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 21 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_21.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 22 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_22.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 23 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_23.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 24 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_24.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 25 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_25.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 26 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_26.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 27 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_27.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 28 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_28.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 29 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_29.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 30 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_30.txt  &


# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 31 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_31.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 32 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_32.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 33 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_33.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 34 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_34.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 35 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_35.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 36 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_36.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 37 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_37.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 38 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_38.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 39 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_39.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 40 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_40.txt  &


# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 41 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_41.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 42 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_42.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 43 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_43.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 44 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_44.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 45 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_45.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 46 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_46.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 47 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_47.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 48 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_48.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 49 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_49.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 50 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_50.txt  &


# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 51 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_51.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 52 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_52.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 53 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_53.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 54 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_54.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 55 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_55.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 56 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_56.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 57 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_57.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 58 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_58.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 59 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_59.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 60 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_60.txt  &

# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 61 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_61.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 62 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_62.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 63 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_63.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 64 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_64.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 65 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_65.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 66 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_66.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 67 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_67.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 68 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_68.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 69 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_69.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 70 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_70.txt  &

# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 71 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_71.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 72 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_72.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 73 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_73.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 74 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_74.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 75 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_75.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 76 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_76.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 77 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_77.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 78 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_78.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 79 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_79.txt  &
# python -m experiments.run_experiment -dataset cifar_contextual  -stream_size 10000 -p 80 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_cifar_classifier_80.txt  &



#HIV
declare -a budget=(10 20 30 40 50 100 150 200 250 400 650 800 1400 2000)
declare -a num_reals=(200)
declare -a which_methods=(1 0 0 0 0 0 0 1 0 0 0)
python -m experiments.run_experiment -dataset HIV_contextual -stream_size 4000 -p 0 -num_reals ${num_reals[@]}  -budget ${budget[@]}  -which_methods ${which_methods[@]} > ./task7/task7_HIV_mp_cams.txt &

#policies
declare -a which_methods=(0 0 0 0 0 0 1 0 0 0 0)
python -m experiments.run_experiment -dataset HIV_contextual -stream_size 4000 -p 0 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_HIV_classifier_0.txt  &
python -m experiments.run_experiment -dataset HIV_contextual -stream_size 4000 -p 1 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_HIV_classifier_1.txt  &
python -m experiments.run_experiment -dataset HIV_contextual -stream_size 4000 -p 2 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_HIV_classifier_2.txt  &
python -m experiments.run_experiment -dataset HIV_contextual -stream_size 4000 -p 3 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_HIV_classifier_3.txt  &
python -m experiments.run_experiment -dataset HIV_contextual -stream_size 4000 -p 4 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_HIV_classifier_4.txt  &



#DRIFT
declare -a budget=(10 20 30 40 50 100 150 200 400 800 1800 2000)
declare -a num_reals=(100)
declare -a which_methods=(1 0 0 0 0 0 0 1 0 0 0)
python -m experiments.run_experiment -dataset drift_contextual -stream_size 3000 -p 1 -num_reals ${num_reals[@]} -budget ${budget[@]}  -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_mp_cams.txt &


#policies
declare -a which_methods=(0 0 0 0 0 0 1 0 0 0 0)
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 0 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_0.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 1 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_1.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 2 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_2.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 3 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_3.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 4 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_4.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 5 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_5.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 6 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_6.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 7 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_7.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 8 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_8.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 9 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_9.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 10 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_10.txt  &
python -m experiments.run_experiment -dataset drift_contextual  -stream_size 3000 -p 11 -num_reals ${num_reals[@]}   -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_DRIFT_classifier_11.txt  &



#VERTEBRAL
declare -a budget=(2 12 20 30 40 50 60 80)
declare -a num_reals=(50)
declare -a which_methods=(1 0 0 0 0 0 0 1 0 0 0)
python -m experiments.run_experiment -dataset VERTEBRAL_contextual  -stream_size 80 -p 0 -num_reals ${num_reals[@]} -budget ${budget[@]}  -which_methods ${which_methods[@]} > ./task7/task7_VERTEBRAL_mp_cams.txt &


#policies
declare -a which_methods=(0 0 0 0 0 0 1 0 0 0 0)
python -m experiments.run_experiment -dataset VERTEBRAL_contextual  -stream_size 80 -p 0 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_VERTEBRAL_classifier_0.txt  &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual  -stream_size 80 -p 1 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_VERTEBRAL_classifier_1.txt  &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual  -stream_size 80 -p 2 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_VERTEBRAL_classifier_2.txt  &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual  -stream_size 80 -p 3 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_VERTEBRAL_classifier_3.txt  &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual  -stream_size 80 -p 4 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_VERTEBRAL_classifier_4.txt  &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual  -stream_size 80 -p 5 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_VERTEBRAL_classifier_5.txt  &
python -m experiments.run_experiment -dataset VERTEBRAL_contextual  -stream_size 80 -p 6 -num_reals ${num_reals[@]} -budget ${budget[@]} -which_methods ${which_methods[@]} > ./task7/task7_VERTEBRAL_classifier_6.txt  &

